﻿// NaverAppSetupTemplate.cpp : 응용 프로그램에 대한 진입점을 정의합니다.
//

#include "stdafx.h"
#include "NaverAppSetupTemplate.h"
#include "shellapi.h"
#include "shlobj.h"
#include "registry.h"

#define MAX_LOADSTRING 100
#define APP_POSTFIX_TITLE "설치"

typedef BOOL (WINAPI *PGETDISKFREESPACEEX)(LPCSTR,PULARGE_INTEGER, PULARGE_INTEGER, PULARGE_INTEGER);

DWORD	ExecuteSetup(LPTSTR szSetupFilePath, LPTSTR szAppCmdLine);
int		ExtractFileName(LPTSTR pszFilePath);
bool	CheckAndExecuteApp(LPCSTR szAppName);
bool	CheckAndNavigateURL(LPCSTR szAppName);
bool	CheckAndSetAutoStart(LPCSTR szAppName, LPCSTR szAppKey);
bool	CheckAndStartWebPage(LPCSTR szAppName);
void	DeleteTempFile(LPTSTR szTempSubPath, LPTSTR szAppSetupFile);
INT64	MyGetDiskFreeSpaceEx(LPCSTR pszDrive);
bool	NewCheckAndExecuteApp(LPCSTR szAppName, LPCSTR szTempIniFile);
bool	NewCheckAndNavigateURL(LPCSTR szAppName, LPCSTR szTempIniFile);
bool	NewCheckAndSetAutoStart(LPCSTR szAppName, LPCSTR szAppKey, LPCSTR szTempIniFile);
bool	NewCheckAndStartWebPage(LPCSTR szAppName, LPCSTR szTempIniFile);
bool	CheckAndPostToolbarProc(LPCSTR szAppName);
HRESULT NPSHGetFolderPath(int csidl, LPTSTR szPath);
bool	CheckUACOn();
bool	CheckAdminMode();
bool	CheckVista();
DWORD	ExecProgram(CString szStrCommand);

typedef HRESULT (WINAPI * SHGetFolderPathProc)(
	HWND hwndOwner,
	int nFolder,
	HANDLE hToken,
	DWORD dwFlags,
	LPSTR pszPath
	);

BOOL CALLBACK AlertAdminProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	TCHAR	szAppCmdLine[MAX_PATH] = {NULL};
	TCHAR	szAppSetupName[MAX_LOADSTRING];
	TCHAR	szAppSetupKey[MAX_LOADSTRING];
	TCHAR	szAppTitle[MAX_PATH] = {NULL};
	TCHAR	szTempPath[MAX_PATH] = {NULL};
	TCHAR	szTempSubPath[MAX_PATH] = {NULL};
	TCHAR	szAppSetupFile[MAX_PATH] = {NULL};

	HRSRC	hResource	= 0;
	HGLOBAL	hResData	= 0;
	DWORD	dwResSize	= 0;
	LPVOID	lpData		= NULL;
	HANDLE	hFile		= NULL;
	DWORD	dwByteWrite = 0;


  /*  WNDCLASS wc; 
 
    // Register the main window class. 
    wc.style = CS_HREDRAW | CS_VREDRAW; 
    wc.lpfnWndProc = (WNDPROC) NULL; 
    wc.cbClsExtra = 0; 
    wc.cbWndExtra = 0; 
    wc.hInstance = hInstance; 
    wc.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_NAVERAPPSETUPTEMPLATE)); 
    //wc.hCursor = LoadCursor(hInstance, IDC_ARROW); 
    //wc.hbrBackground = GetStockObject(WHITE_BRUSH); 
    wc.lpszMenuName =  NULL; 
    wc.lpszClassName = "NaverAppSetupClass"; 
 
    if (!RegisterClass(&wc)) 
       return -1; 
*/

	//1. Temp 폴더 및 이름을 설정한다.
	_tcscpy(szAppCmdLine, lpCmdLine);
	LoadString(hInstance, IDS_APPSETUP_NAME, szAppSetupName, MAX_LOADSTRING);
	LoadString(hInstance, IDS_APPSETUP_KEY, szAppSetupKey, MAX_LOADSTRING);

	wsprintf(szAppTitle, "%s %s", szAppSetupName, APP_POSTFIX_TITLE);


	// 실행시 Param이 있는 경우는 경고창을 띄우지 않는다.
	CString strTempCmdLine = szAppCmdLine;
	CString strCmdLine = szAppCmdLine;
	strTempCmdLine.MakeLower();
	int nNoAlertPos				= -1;
	int nJustExtract			= -1;
	int nJustPostScript			= -1;

	nNoAlertPos = strTempCmdLine.Find(_T("/noalert"));
	if (nNoAlertPos >= 0) {
		strCmdLine.Delete(nNoAlertPos, 8);
		_tcscpy(szAppCmdLine, strCmdLine);
	}

	nJustExtract = strTempCmdLine.Find(_T("/extract"));
	nJustPostScript = strTempCmdLine.Find(_T("/postscript"));

	bool bVista = CheckVista();
	//bVista = true;

	if (bVista) {
		if ( nNoAlertPos < 0 ) 
		{
			bool bUACOn = CheckUACOn();
			bool bAdminMode = CheckAdminMode();

			//if (bUACOff && !bAdminMode) {
			if (!bUACOn && !bAdminMode) {

				TCHAR szTitle[200];
				sprintf(szTitle, _T("일반 사용자에서 UAC를 사용하지 않도록 설정되어\r\n있음으로 %s을(를) 설치할 수 없습니다.\r\n\r\nUAC를 사용하기로 변경하시고 설치 해 주세요."), szAppSetupName);
				MessageBox(NULL, szTitle, _T("네이버 어플리케이션 안내"), MB_OK);

				return -1;

			}
			if (bAdminMode && bUACOn) {
				if (DialogBox(hInstance, MAKEINTRESOURCE(IDD_ADMINMODE_DLG), NULL, (DLGPROC)AlertAdminProc) != IDOK) 
				{
					return -1;
				}
			}
		}
	}

	DWORD lExitCode = 0;
	if( -1 == nJustPostScript )
	{
		GetTempPath(sizeof(szTempPath), szTempPath);
//		wsprintf(szTempSubPath, "%s\\%08x", szTempPath, GetTickCount());
		wsprintf(szTempSubPath, "%s\\Naver", szTempPath);
		CreateDirectory(szTempSubPath, 0);

		/*
		//Temp실행화일이름 : 임의로 만드는 경우
		wsprintf(szAppSetupFile, "%s\\%sSetup.exe", szTempSubPath, szAppSetupName);
		*/
		//Temp실행화일이름 : 임의로 만드는 경우
		TCHAR szModuleFileName[MAX_PATH] = {NULL};
		GetModuleFileName(NULL, szModuleFileName, MAX_PATH);
		// ====================
		TCHAR szSystemFolder[MAX_PATH+1];   // buffer for string
		TCHAR szVolume[10] = {NULL};
		GetSystemDirectory(szSystemFolder, MAX_PATH+1);
		_tcsncpy(szVolume, szSystemFolder, 3);
		DWORD nFreeDiskSize = MyGetDiskFreeSpaceEx(szVolume);
		// ==============
		ExtractFileName(szModuleFileName);
		wsprintf(szAppSetupFile, "%s\\%s", szTempSubPath, szModuleFileName);

		//2. Resource에서 AppSetup.exe을 찾아 Temp에 푼다
		hResource = FindResource(hInstance, MAKEINTRESOURCE(IDR_APP_SETUP), "APP_SETUP");
		dwResSize = SizeofResource(hInstance, hResource);

		//==========
		/*
		if (nFreeDiskSize < dwResSize*2) {
			MessageBox(NULL, _T("디스크 용량이 부족합니다."), szAppTitle, MB_OK);
			return -1;
		}
		*/
		//=============
		hResData = LoadResource(hInstance, hResource);
		if (hResData != NULL && dwResSize != 0)
		{
			lpData = NULL;
			lpData = LockResource(hResData);
			hFile = CreateFile(szAppSetupFile, GENERIC_WRITE, FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
			if ( (NULL != hFile) && (INVALID_HANDLE_VALUE != hFile) ) { 
				SetFilePointer(hFile, 0, 0, FILE_BEGIN);
				WriteFile(hFile, (LPBYTE)lpData, dwResSize, &dwByteWrite, NULL);
				if (NULL != hFile) {CloseHandle(hFile);}
				hFile = NULL;
			} else {

				MessageBox(NULL, _T("Temp화일을 생성할 수 없습니다"), szAppTitle, MB_OK);
				DeleteTempFile(szTempSubPath, szAppSetupFile);
				return -1;
			}
		}

		if( -1 != nJustExtract )
		{
			MessageBox( NULL, _T("Just Extract"), _T("Message"), 0 );
			return 1;
		}

		//3. 실행시킨후 종료할때까지 기다린다.
		lExitCode = ExecuteSetup(szAppSetupFile, szAppCmdLine);


		// Temp관련 화일 및 폴더를 지운다.
		DeleteTempFile(szTempSubPath, szAppSetupFile);

		//OutputDebugString(_T("★1. Original Setup 완료"));
	}//End Of nJustPostScript

	if (lExitCode == 0) 
	{
		//4. 종료후 Regstry를 검색하여 해당화일을 실행시킨다
		TCHAR szTempIniFile[MAX_PATH] = {NULL};
		TCHAR szCommonPath[MAX_PATH] = {NULL};

		NPSHGetFolderPath(CSIDL_COMMON_APPDATA, szCommonPath);
		if (_tcslen(szCommonPath) == 0)
			wsprintf(szTempIniFile, "%s%s.ini", szTempPath, szAppSetupName);
		else
			wsprintf(szTempIniFile, "%s%s.ini", szCommonPath, szAppSetupName);

		//OutputDebugString(_T("★2. RunOnce Check 시작"));

		//if (!NewCheckAndExecuteApp(szAppSetupName, szTempIniFile))
		CheckAndExecuteApp(szAppSetupName);

		//OutputDebugString(_T("★2. RunOnce Check 끝"));

		//if (!NewCheckAndNavigateURL(szAppSetupName, szTempIniFile))
		CheckAndNavigateURL(szAppSetupName);
		
		//if (!NewCheckAndSetAutoStart(szAppSetupName, szAppSetupKey, szTempIniFile))
		CheckAndSetAutoStart(szAppSetupName, szAppSetupKey);
		
		//if (!NewCheckAndStartWebPage(szAppSetupName, szTempIniFile))
		CheckAndStartWebPage(szAppSetupName);

		CheckAndPostToolbarProc(szAppSetupName);

		DeleteFile(szTempIniFile);
	}
	//OutputDebugString(_T("★1. Bootstrap Setup 완료"));

	return lExitCode;
}

void DeleteTempFile(LPTSTR szTempSubPath, LPTSTR szAppSetupFile)
{
	WIN32_FIND_DATA FindFileData;
	if (INVALID_HANDLE_VALUE != FindFirstFile(szTempSubPath, &FindFileData))
	{
		DeleteFile(szAppSetupFile);
		RemoveDirectory(szTempSubPath);
	}
}

bool CheckAndNavigateURL(LPCSTR szAppName)
{
	TCHAR KeyStr[512];
	TCHAR szReadBuffer[MAX_PATH] = {NULL};
	HKEY hRegKey = NULL;
	int  nMaxSize = 1024;
	_tcscpy(szReadBuffer, _T(""));

	wsprintf(KeyStr, _T("Software\\NHN Corporation\\%s"), szAppName);
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, KeyStr, 0, KEY_QUERY_VALUE, &hRegKey) != ERROR_SUCCESS)
		return false;

	if (ERROR_SUCCESS != RegQueryValueEx(hRegKey, "NavigateOnce", 0, 0, (LPBYTE)szReadBuffer, (LPDWORD)&nMaxSize))
	{
		RegCloseKey(hRegKey);
		return false;
	} 

	ShellExecute(NULL, _T("open"), szReadBuffer, _T(""), _T(""), SW_SHOWNORMAL);

	RegCloseKey(hRegKey);

	return true;
}

bool NewCheckAndNavigateURL(LPCSTR szAppName, LPCSTR szTempIniFile)
{
	TCHAR szReadBuffer[MAX_PATH] = {NULL};

	GetPrivateProfileString(_T("Auto"), _T("NavigateOnce"), _T(""), szReadBuffer, MAX_PATH, szTempIniFile);
    if (_tcslen(szReadBuffer) == 0)
	{
		return false;
	}
	ShellExecute(NULL, _T("open"), szReadBuffer, _T(""), _T(""), SW_SHOWNORMAL);
	return true;
}


bool NewCheckAndExecuteApp(LPCSTR szAppName, LPCSTR szTempIniFile)
{
	TCHAR szReadBuffer[MAX_PATH] = {NULL};

	GetPrivateProfileString(_T("Auto"), _T("RunOnce"), _T(""), szReadBuffer, MAX_PATH, szTempIniFile);
    if (_tcslen(szReadBuffer) == 0)
	{
		return false;
	}

	WIN32_FIND_DATA FindFileData;
	if (INVALID_HANDLE_VALUE != FindFirstFile(szReadBuffer, &FindFileData))
	{
		ShellExecute(NULL, _T("open"), szReadBuffer, _T(""), _T(""), SW_SHOWNORMAL);
	}
	return true;
}

bool CheckAndExecuteApp(LPCSTR szAppName)
{
	TCHAR KeyStr[512];
	TCHAR szReadBuffer[MAX_PATH] = {NULL};
	HKEY hRegKey = NULL;
	int  nMaxSize = 1024;
	_tcscpy(szReadBuffer, _T(""));

	wsprintf(KeyStr, _T("Software\\NHN Corporation\\%s"), szAppName);
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, KeyStr, 0, KEY_QUERY_VALUE, &hRegKey) != ERROR_SUCCESS)
		return false;

	if (ERROR_SUCCESS != RegQueryValueEx(hRegKey, "RunOnce", 0, 0, (LPBYTE)szReadBuffer, (LPDWORD)&nMaxSize))
	{
		RegCloseKey(hRegKey);
		return false;
	} 

	CString szRunPath;
	TCHAR * pszToken = _tcstok(szReadBuffer, _T("|"));
	while(pszToken)
	{
		szRunPath = pszToken;
		if (!szRunPath.IsEmpty())
		{
/*			CString szDebug;
			szDebug.Format(_T("실행 : [%s]"), szRunPath);
			OutputDebugString(szDebug);
*/			ExecProgram(szRunPath);
		}
		pszToken = _tcstok(NULL, _T("|"));
	}

	//ExecProgram(szReadBuffer);

	RegCloseKey(hRegKey);

	return true;
}

DWORD ExecProgram(CString szStrCommand)
{

/*	PROCESS_INFORMATION pi;
	STARTUPINFO si;

	ZeroMemory( &si, sizeof(si) );
	si.cb = sizeof(si);
	ZeroMemory( &pi, sizeof(pi) );


	//ShellExecute(NULL, _T("open"), szReadBuffer, _T(""), _T(""), SW_SHOWNORMAL);
	CString strExeCommand;
	strExeCommand.Format("\"%s\"", szStrCommand);
	BOOL retn = ::CreateProcess( NULL, (LPSTR)strExeCommand.GetBuffer(0), NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi );		
*/

	CString szStrCmd, szStrParam;

	szStrCmd = szStrCommand;
	szStrParam = _T("");

	TCHAR val = szStrCommand.GetAt(0);

	if ( (val=='"') || (val=='\''))
	{
		int epos = szStrCommand.Find(val, 1);
		if (epos>=0)
		{
			szStrCmd = szStrCommand.Mid(1, epos-1);
			szStrParam = szStrCommand.Mid(epos+2);
		}
	}
	else
	{
/*		int epos = szStrCommand.Find(' ', 0);
		if (epos>=0)
		{
			szStrCmd = szStrCommand.Mid(0,epos);
			szStrParam = szStrCommand.Mid(epos+2);
		}
*/	}

	SHELLEXECUTEINFO sei = { sizeof(sei) };
	sei.fMask = SEE_MASK_NOCLOSEPROCESS;
	sei.nShow = SW_SHOWNORMAL; // added 27 Nov
	sei.lpVerb = "open";
	sei.lpFile = szStrCmd;
	sei.lpParameters = szStrParam;
	BOOL bRet = ShellExecuteEx(&sei);

	CString szBug;
	if (!bRet) {
		szBug.Format(_T("Cannot [%s] Program!!!"), szStrCommand);
		OutputDebugString(szBug);
		return 1;
	}
	else
	{
		szBug.Format(_T("[%s] Executiton is successfull!!![PID:%ld]"), szStrCommand, sei.hProcess);
		OutputDebugString(szBug);
	}
	return 0;
}
DWORD ExecuteSetup(LPTSTR szSetupFilePath, LPTSTR szAppCmdLine)
{

/*	STARTUPINFO si;
	PROCESS_INFORMATION pi;

	ZeroMemory( &si, sizeof(si) );
	si.cb = sizeof(si);
	ZeroMemory( &pi, sizeof(pi) );

	BOOL bRet = ::CreateProcess(NULL, szSetupFilePath, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
	WaitForSingleObject( pi.hProcess, INFINITE );
	CloseHandle( pi.hProcess );
	CloseHandle( pi.hThread );

	DeleteFile(szSetupFilePath);
*/
	DWORD lExitCode = -1;

	SHELLEXECUTEINFO sei = { sizeof(sei) };
    sei.fMask = SEE_MASK_NOCLOSEPROCESS;
    sei.nShow = SW_SHOWNORMAL; // added 27 Nov
	sei.lpVerb = "open";
    sei.lpFile = szSetupFilePath;
	sei.lpParameters = szAppCmdLine;
    ShellExecuteEx(&sei);

	WaitForSingleObject( sei.hProcess, INFINITE );

	GetExitCodeProcess(sei.hProcess, &lExitCode) ;

	CloseHandle( sei.hProcess );

	//DeleteFile(szSetupFilePath);

	return lExitCode;
};

int ExtractFileName(LPTSTR pszFilePath)
{
	try {
		LPTSTR pBuf = pszFilePath;

		for(int i = _tcslen(pBuf) - 1; i >= 0; i--)
			if(pBuf[i] == _T('\\'))
			{
				_tcscpy(pszFilePath, &(pBuf[i]) + 1);
				return i;
			}

	} catch (...) {
	}
	return 0;
}

bool NewCheckAndSetAutoStart(LPCSTR szAppName, LPCSTR szAppKey, LPCSTR szTempIniFile)
{
	TCHAR szReadBuffer[MAX_PATH] = {NULL};

	GetPrivateProfileString(_T("Auto"), _T("AutoStartOnce"), _T(""), szReadBuffer, MAX_PATH, szTempIniFile);
    if (_tcslen(szReadBuffer) == 0)
	{
		return false;
	} 
	else 
	{
		CRegistry reg(HKEY_CURRENT_USER, _T("Software\\Microsoft\\Windows\\CurrentVersion\\Run"));
		reg.SetValue(szAppKey, REG_SZ, (BYTE*)szReadBuffer, _tcslen(szReadBuffer));
		return true;
	}
}

bool CheckAndSetAutoStart(LPCSTR szAppName, LPCSTR szAppKey)
{
	TCHAR KeyStr[512];
	TCHAR szReadBuffer[MAX_PATH] = {NULL};
	HKEY hRegKey = NULL;
	int  nMaxSize = 1024;
	_tcscpy(szReadBuffer, _T(""));

	wsprintf(KeyStr, _T("Software\\NHN Corporation\\%s"), szAppName);
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, KeyStr, 0, KEY_QUERY_VALUE, &hRegKey) != ERROR_SUCCESS)
		return false;

	if (ERROR_SUCCESS != RegQueryValueEx(hRegKey, "AutoStartOnce", 0, 0, (LPBYTE)szReadBuffer, (LPDWORD)&nMaxSize))
	{
		RegCloseKey(hRegKey);
		return false;
	} 
	RegCloseKey(hRegKey);

	if (_tcslen(szReadBuffer) > 0)
	{
		CRegistry reg(HKEY_CURRENT_USER, _T("Software\\Microsoft\\Windows\\CurrentVersion\\Run"));
		return reg.SetValue(szAppKey, REG_SZ, (BYTE*)szReadBuffer, _tcslen(szReadBuffer));
	} 
	else
		return false;
}

bool NewCheckAndStartWebPage(LPCSTR szAppName, LPCSTR szTempIniFile)
{
	TCHAR szReadBuffer[MAX_PATH] = {NULL};

	GetPrivateProfileString(_T("Auto"), _T("StartWebPageOnce"), _T(""), szReadBuffer, MAX_PATH, szTempIniFile);
    if (_tcslen(szReadBuffer) == 0)
	{
		return false;
	} else {
        CRegistry reg(HKEY_CURRENT_USER, _T("Software\\Microsoft\\Internet Explorer\\Main"));
		reg.SetValue(_T("Start Page"), REG_SZ, (BYTE*)szReadBuffer, _tcslen(szReadBuffer));
		return true;
	}
}

bool CheckAndStartWebPage(LPCSTR szAppName)
{
	TCHAR KeyStr[512];
	TCHAR szReadBuffer[MAX_PATH] = {NULL};
	HKEY hRegKey = NULL;
	int  nMaxSize = 1024;
	_tcscpy(szReadBuffer, _T(""));

	wsprintf(KeyStr, _T("Software\\NHN Corporation\\%s"), szAppName);
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, KeyStr, 0, KEY_QUERY_VALUE, &hRegKey) != ERROR_SUCCESS)
		return false;

	if (ERROR_SUCCESS != RegQueryValueEx(hRegKey, "StartWebPageOnce", 0, 0, (LPBYTE)szReadBuffer, (LPDWORD)&nMaxSize))
	{
		RegCloseKey(hRegKey);
		return false;
	} 
	RegCloseKey(hRegKey);

	if (_tcslen(szReadBuffer) > 0)
	{
		CRegistry reg(HKEY_CURRENT_USER, _T("Software\\Microsoft\\Internet Explorer\\Main"));
		return reg.SetValue(_T("Start Page"), REG_SZ, (BYTE*)szReadBuffer, _tcslen(szReadBuffer));
	}
	else
		return false;
}

bool CheckAndPostToolbarProc(LPCSTR szAppName)
{
	TCHAR KeyStr[512];
	TCHAR szReadBuffer[MAX_PATH] = {NULL};
	HKEY hRegKey = NULL;
	int  nMaxSize = 1024;
	_tcscpy(szReadBuffer, _T(""));

	wsprintf(KeyStr, _T("Software\\NHN Corporation\\%s"), szAppName);
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, KeyStr, 0, KEY_QUERY_VALUE, &hRegKey) != ERROR_SUCCESS)
		return false;

	if (ERROR_SUCCESS != RegQueryValueEx(hRegKey, "PostInstOnce", 0, 0, (LPBYTE)szReadBuffer, (LPDWORD)&nMaxSize))
	{
		RegCloseKey(hRegKey);
		return false;
	} 
	RegCloseKey(hRegKey);


	WIN32_FIND_DATA FindFileData;
	if (INVALID_HANDLE_VALUE != FindFirstFile(szReadBuffer, &FindFileData))
	{
		ShellExecute(NULL, _T("open"), szReadBuffer, _T(""), _T(""), SW_SHOWNORMAL);
	}

	return true;
}

INT64 MyGetDiskFreeSpaceEx(LPCSTR pszDrive)
{
   INT64 nFreeSize = 0;
   PGETDISKFREESPACEEX pGetDiskFreeSpaceEx;
   __int64 i64FreeBytesToCaller, i64TotalBytes, i64FreeBytes;
   
   DWORD dwSectPerClust, 
         dwBytesPerSect, 
         dwFreeClusters, 
         dwTotalClusters;

   BOOL fResult;

   pGetDiskFreeSpaceEx = (PGETDISKFREESPACEEX) GetProcAddress( 
                           GetModuleHandle("kernel32.dll"),
                          "GetDiskFreeSpaceExA");

   if (pGetDiskFreeSpaceEx)
   {
      fResult = pGetDiskFreeSpaceEx (pszDrive,
                 (PULARGE_INTEGER)&i64FreeBytesToCaller,
                 (PULARGE_INTEGER)&i64TotalBytes,
                 (PULARGE_INTEGER)&i64FreeBytes);

   // Process GetDiskFreeSpaceEx results.
      if(fResult) 
      {
         nFreeSize = i64FreeBytes;
      }
      return nFreeSize;
   }

   else 
   {
      fResult = GetDiskFreeSpaceA (pszDrive, 
                 &dwSectPerClust, 
                 &dwBytesPerSect,
                 &dwFreeClusters, 
                 &dwTotalClusters);

   // Process GetDiskFreeSpace results.
      if(fResult) 
      {
		  nFreeSize = dwFreeClusters*dwSectPerClust*dwBytesPerSect;
      }
      return nFreeSize;
   }
}

HRESULT NPSHGetFolderPath(int csidl, LPTSTR szPath)
{
	HRESULT hResult;

#ifndef _UNICODE
	hResult = E_FAIL;
#else
	hResult = S_FALSE;
#endif

	HMODULE hModule = LoadLibrary(_T("SHFolder.dll"));
	SHGetFolderPathProc SHGetFolderPath = NULL;
	if (hModule)
	{
		TCHAR szPath[MAX_PATH];

#ifndef _UNICODE
		SHGetFolderPath = (SHGetFolderPathProc)GetProcAddress(hModule, _T("SHGetFolderPathA"));
#else
		SHGetFolderPath = (SHGetFolderPathProc)GetProcAddress(hModule, _T("SHGetFolderPathW"));
#endif
		if (SHGetFolderPath)
		{
			hResult = SHGetFolderPath(NULL, csidl, NULL, 0, szPath);
		}
	}

	if (hModule)
		FreeLibrary(hModule);

	return hResult;
}

bool CheckUACOn()
{
	bool bRet = false;

	DWORD dwUACValue = -1;

	CRegistry::GetValueDWORD(HKEY_LOCAL_MACHINE, _T("Software\\Microsoft\\Windows\\CurrentVersion\\Policies\\System"), _T("EnableLUA"), &dwUACValue);
	if (dwUACValue == 1) 
		bRet = true;

	return bRet;
}

bool CheckAdminMode()
{
	return IsUserAnAdmin();
}

bool CheckVista()
{
	bool bRet = false;
	OSVERSIONINFO osvi;
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);

	GetVersionEx (&osvi);

	if ( osvi.dwMajorVersion >= 6 ) 
		bRet = true;
	else
		bRet = false;

	return bRet;
}

BOOL CALLBACK AlertAdminProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{ 
    switch (message) 
    { 
		case WM_INITDIALOG:

			RECT rtWindow, rtWorkArea;
			GetWindowRect(hwndDlg, &rtWindow);
			SystemParametersInfo(SPI_GETWORKAREA, 0, (PVOID)&rtWorkArea, 0);
			SetWindowPos(hwndDlg, NULL, ((rtWorkArea.right + rtWorkArea.left) - (rtWindow.right - rtWindow.left)) / 2,
				((rtWorkArea.bottom + rtWorkArea.top) - (rtWindow.bottom - rtWindow.top)) / 2, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
			return TRUE; 

        case WM_COMMAND: 
            switch (LOWORD(wParam)) 
            { 
                case IDOK: 
 					EndDialog(hwndDlg, wParam);
 
                case IDCANCEL: 
                    EndDialog(hwndDlg, wParam); 
                    return TRUE; 
            } 
    } 
    return FALSE; 
} 